struct __w32_PROCESS_INFORMATION
{
	unsigned int hProcess;
	unsigned int hThread;
	unsigned int dwProcessId;
	unsigned int dwThreadId;
}

struct __w32_SECURITY_ATTRIBUTES
{
	unsigned int nLength;
	void *lpSecurityDescriptor;
	int bInheritHandle;
}

struct __w32_STARTUPINFO
{
	unsigned int cb;
	string *lpReserved;
	string *lpDesktop;
	string *lpTitle;
	unsigned int dwX;
	unsigned int dwY;
	unsigned int dwXSize;
	unsigned int dwYSize;
	unsigned int dwXCountChars;
	unsigned int dwYCountChars;
	unsigned int dwFillAttribute;
	unsigned int dwFlags;
	word wShowWindow;
	word cbReserved2;
	byte *lpReserved2;
	unsigned int hStdInput;
	unsigned int hStdOutput;
	unsigned int hStdError;
}

#define PIPE_STILL_ACTIVE 0x103

class PipeProcess
{
	unsigned int m_hReadOut;
	unsigned int m_hWriteOut;
	unsigned int m_hReadErr;
	unsigned int m_hWriteErr;

	__w32_PROCESS_INFORMATION m_pi;
	__w32_SECURITY_ATTRIBUTES m_sa;
	__w32_STARTUPINFO m_si;

	declare PipeProcess();
	declare _PipeProcess();

	declare Open(string *pFileName, string *pArgs);
	declare ReadOut(unsigned int nNumBytes, byte *pBytes),int;
	declare FinalizeOut(unsigned int nNumBytes, byte *pBytes);
	declare ReadErr(unsigned int nNumBytes, byte *pBytes),int;
	declare FinalizeErr(unsigned int nNumBytes, byte *pBytes);
}