#ifndef _CCL_RAW
#define _CCL_RAW

/*****************************/
/*** Use Required Librarys ***/
/*****************************/

#use "ws2_32.lib"

/**************************/
/*** Include Base Class ***/
/**************************/

#include "classes\common.inc"

/************************/
/*** Define Constants ***/
/************************/

#define NOTIMEOUT -1

/*********************************/
/*** Create Raw Internet Class ***/
/*********************************/

class Raw : CCL {

	/* Class Methods */

	declare Raw(); /* Constructor */
	declare _Raw(); /* Deconstructor */

	declare Connect(string address,unsigned word port),int; /* Connect To A Server */
	declare Disconnect(); /* Disconnect An Active Connection */
	
	declare StartServer(unsigned word port),int; /* Start Server */
	declare StopServer(); /* Stop Listening */
	declare Listen(int maxClients),int; /* Listen For Connections */
	declare Accept(int timeout),int; /* Accept A Connection */

	declare Send(string strdata),int; /* Send Data */
	declare Recieve(int bufferLen),int; /* Recieve Data */

	declare ServerSend(string strdata,unsigned int socket),int;
	declare ServerRecieve(int bufferlen,unsigned int socket),int;

	declare GetClientIP(); /* Get Client IP */

	declare virtual OnRecieve(string data,int Bytes); /* Called When Data Is Recieved */
	declare virtual OnSend(string strData,int Bytes); /* Called When Data Is Sent */
	declare virtual OnConnect(unsigned int socket); /* Called When A Client Connects */

	/* Class Members */

	int Initialized;
	unsigned int TempSocket;
	unsigned int TempClient;

}

#endif