#ifndef _CCL_REGISTRY
#define _CCL_REGISTRY

/**************************/
/*** Include Base Class ***/
/**************************/

#include "classes\common.inc"

/************************/
/*** Define Constants ***/
/************************/

#define CCL_HKCR 0x80000000
#define CCL_HKCU 0x80000001
#define CCL_HKLM 0x80000002
#define CCL_HKUSERS 0x80000003
#define CCL_HKPD 0x80000004
#define CCL_HKCC 0x80000005
#define CCL_HKDD 0x80000006

#define CCL_ALL_ACCESS 0xF003F
#define CCL_CREATE_SUBKEY 0x0004
#define CCL_ENUMERATE_SUBKEYS 0x0008
#define CCL_NOTIFY 0x0010
#define CCL_QUERY_VALUE 0x0001
#define CCL_READ 0x20019
#define CCL_SET_VALUE 0x0002
#define CCL_WRITE 0x20006

#define CCL_REG_NONE 0
#define CCL_REG_SZ 1
#define CCL_REG_EXPAND_SZ 2
#define CCL_REG_BINARY 3
#define CCL_REG_DWORD 4
#define CCL_REG_DWORD_LITTLE_ENDIAN 4
#define CCL_REG_DWORD_BIG_ENDIAN 5
#define CCL_REG_LINK 6
#define CCL_REG_MULTI_SZ 7
#define CCL_REG_RESOURCE_LIST 8
#define CCL_REG_FULL_RESOURCE_DESCRIPTOR 9
#define CCL_REG_RESOURCE_REQUIREMENTS_LIST 10

#define CCL_LEN_STRING 255

#define CCL_REG_SUCCESS 0
#define CCL_REG_FAIL 1

/*****************************/
/*** Create Registry Class ***/
/*****************************/

class Registry : CCL {

	/* Constructor And Destructor */

	declare Registry();
	declare _Registry();

	/* Class Mehtods */

	declare CreateKey(unsigned int hKey,string strSubKey,opt unsigned int dwOptions=CCL_ALL_ACCESS,opt pointer pClass=0),int;
	declare DeleteKey(string subkey, opt unsigned int hKey=0),int;
	declare OpenKey(unsigned int hKey, string strSubKey, opt unsigned int dwOptions=CCL_ALL_ACCESS);
	declare CloseKey();

	declare SetValue(string value, pointer data, opt unsigned int value_type=CCL_REG_SZ, opt unsigned int __size);
	declare DeleteValue(string valuename);
	declare GetValue(string valuename, pointer data_out, unsigned int size_data, unsigned int type byref),int;

	declare Key(),unsigned int;

	/* Class Members */

	unsigned int m_hKey;

}

#endif