/*-----------------------------------------------------------------------------
// File:			sqltypes.inc
//
// Copyright:		Copyright (c) Ionic Wind Software        
//
// Contents: 		This file defines the types used in ODBC
//
// Comments: 		Adapted from sqltypes.h
//
//-----------------------------------------------------------------------------*/

#ifdef __SQLTYPES_INCLUDED
//do nothing
#else
#define __SQLTYPES_INCLUDED

/*
* ODBCVERSION  to include definitions introduced in version 3.5 (or above)
*				uncomment the define.
*/
//#define ODBCVER35
#define ODBCVER30



/* transfer types for DATE, TIME, TIMESTAMP */
struct SQL_DATE_STRUCT {
		WORD year;
        WORD month;
        WORD day;
}


struct SQL_TIME_STRUCT {
		WORD hour;
        WORD minute;
        WORD second;
}


struct SQL_TIMESTAMP_STRUCT {
        WORD year;
        WORD month;
        WORD day;
        WORD hour;
        WORD minute;
        WORD second;
        INT fraction;
} 


/*
 * enumerations for DATETIME_INTERVAL_SUBCODE values for interval data types
 * these values are from SQL-92
 */

#ifdef ODBCVER30
#define SQL_IS_YEAR						 1
#define	SQL_IS_MONTH					 2
#define	SQL_IS_DAY						 3
#define	SQL_IS_HOUR						 4
#define	SQL_IS_MINUTE					 5
#define	SQL_IS_SECOND					 6
#define	SQL_IS_YEAR_TO_MONTH			 7
#define	SQL_IS_DAY_TO_HOUR				 8
#define	SQL_IS_DAY_TO_MINUTE			 9
#define	SQL_IS_DAY_TO_SECOND			 10
#define	SQL_IS_HOUR_TO_MINUTE			 11
#define	SQL_IS_HOUR_TO_SECOND			 12
#define	SQL_IS_MINUTE_TO_SECOND			 13

#endif

#ifdef ODBCVER30
struct SQL_YEAR_MONTH {
	INT year;
	unsigned int month;
}

struct SQL_DAY_SECOND {
	unsigned int day;
	unsigned int hour;
	unsigned int minute;
	unsigned int second;
	unsigned int fraction;
}

/*type SQL_INTERVAL_STRUCT
	SQLINTERVAL		interval_type;
	SQLSMALLINT		interval_sign;
	union {
		SQL_YEAR_MONTH_STRUCT		year_month;
		SQL_DAY_SECOND_STRUCT		day_second;
	} intval;
}*/

#endif


/* internal representation of numeric data type */
#ifdef ODBCVER30
#define SQL_MAX_NUMERIC_LEN  16
struct SQL_NUMERIC_STRUCT {
	byte	precision;
	byte	scale;
	byte	sign;	/* 1 if positive, 0 if negative */
	byte	vals[SQL_MAX_NUMERIC_LEN];
}
#endif 

/* size is 16 */
struct SQLGUID {
    unsigned int Data1;
    WORD Data2;
    WORD Data3;
    byte Data4[ 8 ];
}

#endif
